function [ phat ] = fitstmle( y, start )

phatmat=zeros(41,5);
myoptions=statset('mlecustom');
myoptions.MaxFunEvals=2000;
myoptions.MaxIter=1000;

for df=5:45,
    
    custpdf= @(data,location,scale,shape) dskt(data,location,scale,shape,df); %Skew Normal pdf

    phat = mle(y,'pdf',custpdf,'start',start,'lowerbound',[-4 0.01 -15],'upperbound',[15 15 15],'options',myoptions);
    phatmat(df-4,1:3)=phat;    
    phatmat(df-4,4)=df;
    phatmat(df-4,5)=sum(log(dskt(y(:,1),phat(1),phat(2),phat(3),df))); %log-likelihood value

end;

[c,i]=max(phatmat(:,5));
phat=phatmat(i,1:4); %parameters with maximum likelihood

end

