function sigv=draw_MA1_sig(y,curr_theta,ls,us)

%uniform priors (as in ABC) 
%note the lower and upper bounds are on the sigma space (not sig^2)
T=length(y);
Hpsi = speye(T) + sparse(2:T,1:(T-1),curr_theta*ones(1,T-1),T,T);
x=Hpsi\y;

b = sum(x.^2)/2;
a = T/2;
% sig2 = 1/gamrnd(a,1/b); %IG(a,b) iterate = 1/Y, where Y~Gamma(a,1/b).
sig2=cigrnd( a,b,ls^2,us^2 );
sigv=sqrt(sig2);
end