function [ x_exact ] = xgen_exact( T,d,k,ssig )
%generate x from the continuous time SQ model
%transition density is non-central chi-square

alphval = 1 - k;	
mu_x_exact = d/alphval;
nu = 4*d/(ssig^2);   
delta = (4*alphval*exp(-alphval))/((ssig^2)*(1-exp(-alphval)));
c_val = 2*alphval/((ssig^2)*(1 - exp(-alphval)));

x_exact=zeros(T,1);
x_exact(1) = mu_x_exact;

for i=2:T
%     deltax = delta*x_exact(i-1);
%     poiss = poissrnd(deltax/2);   
%     chisq_df = nu + 2*poiss;
%     x_exact(i) = 2 * gamrnd(chisq_df/2,1);
%     x_exact(i) = x_exact(i)/(2*c_val); 	
    x_exact(i) = drawNCX2( nu, delta, c_val, x_exact(i-1) );
end

end

