% stlike=@(param) -sum(dst2(et,0,1,param(1),param(2),[0,5]));
T=1000;
e=rskt2(T,parameters(4),parameters(5));
stlike=@(param) -sum(log(dskt(e,0,1,param(1),param(2))));

[x,fval,exitflag,output,lambda,grad,hessian] = fmincon(stlike,[-0.5,3.5],[],[],[],[],[-10,2.1],[0,30]);
cov=inv(hessian);
% skurtcoef(x) %since df=2.5, third and fourth moments do not exist.


%plot the density?

[kern,grid]=ksdensity(e);
gpdf=dskt(grid,0,1,x(1),x(2));
plot(grid',[gpdf',kern']);


%% estimating the aux model
clear
clc
omgv=0; rho=0.9;sigv=0.06;
alpha=1.7; T=500;
seed=11223344;
[ y, x ] = gen_SV2_CW( T, omgv,rho, sigv, alpha );
figure;
subplot(2,1,1); plot(y); title('returns');
subplot(2,1,2); plot(x); title('log volatility');
[parameters, LL, ht, VCVrobust, VCV, scores, diagnostics] = tarch(y, 1, 0, 1, 'SKEWT');

% [parameters, likelihood, stderrors, robustSE, ht, scores] = skt_garch(y , 1 , 1 );

% [parameters, likelihood, stderrors, robustSE, ht, scores] = fattailed_garch(y , 1 , 1 , 'STUDENTST');

p1=[parameters(1:(length(parameters)-1));0;parameters(length(parameters))];
[LLF, h1, likelihoods1] = skt_garchlikelihood(p1 , y , 1 , 1, std(y,1), T);

addpath(genpath('C:\Users\Ole\Dropbox\Research\ABC\Revision\SV2_aStab\MFEToolbox'));
[LL,LLS]=skewtloglik(y,0,ht,p1(end),0);

-sum(log(dskt(y./sqrt(ht),0,1,0,p1(end))))


[parameters2, LL2, ht2, VCVrobust2, VCV2, scores2, diagnostics2] = tarch2(y, 1, 0, 1, 'SKEWT');

%% looking at the likelihood surface of the two versions of the density
%generating skew-t(lambda=-0.4, df=4)
x=skewtrnd(4,-0.4,[5000,1]);

%computing the likelihood surface
g=50;
lambg=linspace(-0.9,0.9,g);
betag=lambg./sqrt(1-lambg.^2); %a different parametermization
dfg=linspace(2.1,10,g);

like_ind=zeros(g,g);
like_sm=zeros(g,g);

parfor i=1:g
   for j=1:g
       like_ind(i,j)=skewtloglik(x,0,1,dfg(i),lambg(j));
       like_sm(i,j)=skewtloglik2(x,0,1,dfg(i),betag(j));
   end
end


