function [logscore, QS, CRPS]=calcPredScoresNum(grid,pdfKern,cdfKern,yobs,llim,ulim)

%spline on log pdf
lpdf=spline(grid,log(pdfKern));

%spline on cdf
cdf=spline(grid,cdfKern);

logscore=fnval(lpdf,yobs);

lf=@(x) fnval(lpdf,x);
QS=calcQS(lf,yobs,llim,ulim);

f=@(x) fnval(cdf,x);
CRPS=calcCRPS(f,yobs,llim,ulim);

end