function [lse]=logSumExp(l)
%takes the log(sum(exp(l))), of vector l avoiding the exp() of extreme numbers
%by taking log(sum(exp(l-lstar)))+lstar, where lstar is an extreme (min or
%max) of the vector l.

% maxl=max(l);
% minl=min(l);
% if(abs(maxl)>abs(minl))
%     lstar=max(l);
% else
%     lstar=min(l);
% end
lstar=max(l);
ldev=l-lstar;
lse=lstar+log(sum(exp(ldev)));

end
