function [resids] = resids_MA2(y,theta1,theta2)
%theta is entered as a 1xM
T=length(y);
M=length(theta1);

%initialize e0 at zero
e0=zeros(1,M);

resids=zeros(T,M);

for i=1:T
   if(i==1)
       resids(i,:)=y(i)-theta1.*e0-theta2.*e0;
   elseif(i==2)
       resids(i,:)=y(i)-theta1.*resids(i-1,:)-theta2.*e0;
   else
       resids(i,:)=y(i)-theta1.*resids(i-1,:)-theta2.*resids(i-2,:);
   end
end

end