function sigv=draw_SV_sigv(curr_h,d,curr_k,ls,us)

%uniform priors (as in ABC) 
%note the lower and upper bounds are on the sigma space (not sig^2)

T=length(curr_h);
b = sum([(curr_h(1)-d)*sqrt(1-curr_k^2); curr_h(2:end)-curr_k*curr_h(1:end-1)-d].^2)/2;
a = T/2;
% sig2 = 1/gamrnd(a,1/b); %IG(a,b) iterate = 1/Y, where Y~Gamma(a,1/b).
sig2=cigrnd( a,b,ls^2,us^2 );
sigv=sqrt(sig2);
end