function [OVL, OVLP]=calcOVL(grid,f1kern,f2kern,llim,ulim)

%spline on f1
f1=spline(grid,f1kern);

%spline on f2
f2=spline(grid,f2kern);

f=@(x) min(fnval(f1,x),fnval(f2,x));

OVL=integral(f,llim,ulim);
OVLP=OVL^2;