function [lse]=logSumExp2D(l)
%takes the log(sum(exp(l))), of vector l avoiding the exp() of extreme numbers
%by taking log(sum(exp(l-lstar)))+lstar, where lstar is an extreme (min or
%max) of the vector l.

lmax=max(l(:));
lstar=lmax;
ldev=l-lstar;
lse=lstar+log(sum(sum(exp(ldev))));
end
