function [normw, lse]=normLogWeights(lw)
%takes the log(sum(exp(l))), of vector l avoiding the exp() of extreme numbers
%by taking log(sum(exp(l-lstar)))+lstar, where lstar is an extreme (max)
lse=logSumExp(lw);

%normalise the weight matrix lw in the log
norm_lw=lw-lse;
normw=exp(norm_lw);

end
