function [ y, x ] = gen_SV( T, d, k, sigv )
    alpha=1-k;
    marg_mean_ou = d/alpha;
    marg_var_ou = (sigv^2)/(1-k^2);
    cond_var_ou = sigv^2;

    int_ou = d;  
    sl_ou = k;                    

    x=zeros(T,1);
    for i=1:T
        if(i==1)
            x(i)=normrnd(marg_mean_ou,sqrt(marg_var_ou));
        else
            x(i)=int_ou+sl_ou*x(i-1)+normrnd(0,sqrt(cond_var_ou));
        end
    end
    y=exp(x/2).*normrnd(0,1,T,1);
end

